Subject: [Ietf-calsify] ALTREP and ATTACH

From: camerost at exchange.microsoft.com (Cameron Stillion)
Date: Thu Aug 19 15:41:08 2004

This discrepancy seems broken to me, and it seems to be very unclearly
stated in the document.  The MIME structure in particular is left to our
imagination.

Just so that I understand the Notes implementation - is this correct?

multipart/related
 |
 \_text/ical
 |
 \_text/html
 |
 \_multipart/mixed
    |
    \_ image/gif
    |
    etc...

Or am I misunderstanding you?

Cameron

-----Original Message-----
From: [email-masked]
[mailto:[email-masked]] On Behalf Of
[email-masked]
Sent: Thursday, August 19, 2004 3:18 PM
To: [email-masked]
Subject: Re: [Ietf-calsify] ALTREP and ATTACH

Notes has implemented ALTREP  and  ATTACH features.
The ALTREP cid value points to a text/html in the same MIME stream as
the text/calendar but in a multipart/related section.
 In ATTACHMENT cid value points to a attachment in the same MIME stream
but  in a multipart/mix section.

The iCalendar spec allows the ATTACH to be encoded directly into the
iCalendar stream.  Notes code does not use that option.
I don't think the ALTREP parameter has any provisions for inserting the
image within the iCalendar data.

"Cameron Stillion" <[email-masked]> Sent by:
[email-masked]
08/19/2004 06:01 PM

To
<[email-masked]>
cc

Subject
[Ietf-calsify] ALTREP and ATTACH

Section 4.2.1 of RFC2445 contains this example:
 
Example:

     DESCRIPTION;ALTREP="CID:<[email-masked]>":Project
       XYZ Review Meeting will include the following agenda items: (a)
       Market Overview, (b) Finances, (c) Project Management

   The "ALTREP" property parameter value might point to a "text/html"
   content portion.

     Content-Type:text/html
     Content-Id:<[email-masked]>

     <html><body>
     <p><b>Project XYZ Review Meeting</b> will include the following
     agenda items:<ol><li>Market
     Overview</li><li>Finances</li><li>Project Management</li></ol></p>
     </body></html>

I haven't found any clients that actually support this, but if they did
- it isn't clear from the context of this example where the "content
portion" mentioned above actually lives.  possibility #1) Is the .ics
file contained in a multipart/related MIME portion of a message that
also contains this text/html body part?  OR - possibility #2) Is this
"content portion" actually inside of the iCal itself? The example isn't
quite clear, but I'm guessing that #1 is the answer, and the rest of
these details are simply left out.  If I'm reading this correctly, there
doesn't seem to be any means of specifying the format of the DESCRIPTION
text.  Does this mean it is limited to plain text? BioCity seems to
generate DESCRIPTIONS with ENCODING parameter and with actual inline
HTML content. I suppose clients could parse the description, discover
HTML-like tags, guess it's HTML, and do the right thing... but that
seems flimsy to me.  Shouldn't we specify the format if it is not plain
text?  What do other clients do?
 
The second half of this question concerns attachments.  There is a very
direct mechanism for inlining content, but only if it is BINARY.  It
also has an ENCODING parameter (this time, it's in the spec) and
apparently, a way to refer to another "content portion" - again,
non-specific if this is referring to a mechanism of referencing sibling
attachments in a MIME structure, or simply referencing something in the
iCal itself.  Again, my assumption is that it is related to a MIME
structure.  But, does anyone actually generate or read this kind of
complex multipart/related content?
 
My gut feeling is that these concepts are closely related and that there
should be very similar mechanisms for inlining or outlining content,
specifying format, etc. for both attachments and the body of the event.
And, am I the only one interested in storing HTML descriptions of
events?
 
cameron
 
_______________________________________________
Ietf-calsify mailing list
[email-masked]
http://lists.osafoundation.org/mailman/listinfo/ietf-calsify

---

From: Robert_Ransdell at notesdev.ibm.com ([email-masked])
Date: Fri Aug 20 08:20:00 2004

Message-ID: 
<[email-masked]>
From: [email-masked]
Date: Fri, 20 Aug 2004 11:08:32 -0400
Content-Type: multipart/mixed; boundary="=_mixed 005333BD85256EF6_="

--=_mixed 005333BD85256EF6_=
Content-Type: multipart/related; boundary="=_related 005333BF85256EF6_="

--=_related 005333BF85256EF6_=
Content-Type: multipart/alternative; boundary="=_alternative 
005333BF85256EF6_="

--=_alternative 005333BF85256EF6_=
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: quoted-printable

--=_alternative 005333BF85256EF6_=
Content-Type: text/html; charset=US-ASCII
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

(html content removed)

--=_alternative 005333BF85256EF6_=
Content-Type: text/calendar; method="REQUEST"; charset="UTF-8"

BEGIN:VCALENDAR
X-LOTUS-CHARSET:UTF-8
VERSION:2.0
PRODID:-//Lotus Development Corporation//NONSGML Notes 6.0//EN
METHOD:REQUEST
BEGIN:VTIMEZONE
TZID:Eastern
BEGIN:STANDARD
DTSTART:19501029T020000
TZOFFSETFROM:-0400
TZOFFSETTO:-0500
RRULE:FREQ=YEARLY;BYMINUTE=0;BYHOUR=2;BYDAY=-1SU;BYMONTH=10
END:STANDARD
BEGIN:DAYLIGHT
DTSTART:19500402T020000
TZOFFSETFROM:-0500
TZOFFSETTO:-0400
RRULE:FREQ=YEARLY;BYMINUTE=0;BYHOUR=2;BYDAY=1SU;BYMONTH=4
END:DAYLIGHT
END:VTIMEZONE
BEGIN:VEVENT
DTSTART;TZID="Eastern":20040829T090000
DTEND;TZID="Eastern":20040829T100000
TRANSP:OPAQUE
DTSTAMP:20040820T150832Z
SEQUENCE:0
ATTACH:CID:1__=[email-masked]
ATTENDEE;ROLE=CHAIR;PARTSTAT=ACCEPTED;CN="bravo bravo/ibm";RSVP=FALSE:
 mailto:[email-masked]
ATTENDEE;ROLE=REQ-PARTICIPANT;PARTSTAT=NEEDS-ACTION
 ;CN="POP3 Testing/ibm";RSVP=TRUE
 :mailto:[email-masked]
CLASS:PUBLIC
DESCRIPTION;ALTREP="CID:<FFFF__=[email-masked]>":t
 here is an image below\n\n\nthere is also a vCard attachment\n
SUMMARY:sample mime structure
ORGANIZER;CN="bravo bravo/ibm"
 :mailto:[email-masked]
UID:63EDEBC01243D46185256EF60052D8F2-Lotus_Notes_Generated
X-LOTUS-BROADCAST:FALSE
X-LOTUS-UPDATE-SEQ:1
X-LOTUS-UPDATE-WISL:$S:1;$L:1;$B:1;$R:1;$E:1
X-LOTUS-NOTESVERSION:2
X-LOTUS-NOTICETYPE:I
X-LOTUS-CHILD_UID:63EDEBC01243D46185256EF60052D8F2
END:VEVENT
END:VCALENDAR

--=_alternative 005333BF85256EF6_=--
--=_related 005333BF85256EF6_=
Content-Type: image/gif; name=ecblank.gif
Content-Disposition: inline; filename=ecblank.gif
Content-ID: <2__=[email-masked]>
Content-Transfer-Encoding: base64

R0lGODlhEAABAIAAAAAAAP///yH5BAEAAAEALAAAAAAQAAEAAAIEjI8ZBQA7

--=_related 005333BF85256EF6_=
Content-Type: image/gif; name=pic10487.gif
Content-Disposition: inline; filename=pic10487.gif
Content-ID: <3__=[email-masked]>
Content-Transfer-Encoding: base64

R0lGODlh+gABAID/AMDAwAAAACH5BAEAAAAALAAAAAD6AAEAAAINhI+py+0Po5y02ovzLQA7

--=_related 005333BF85256EF6_=
Content-Type: image/jpeg; name=C2822823.jpg
Content-Disposition: inline; filename=C2822823.jpg
Content-ID: <4__=[email-masked]>
Content-Transfer-Encoding: base64

(image content removed)

--=_related 005333BF85256EF6_=
Content-Type: text/html; charset=US-ASCII
Content-Disposition: inline
Content-ID: <FFFF__=[email-masked]>
Content-Transfer-Encoding: quoted-printable

<html><body><font size=3D"2">there is an image below</font><br>
<img src=3D"cid:4__=[email-masked]" width=3D=
"366" height=3D"227"><br>
there is also a vCard attachment<br>
<i>(See attached file: ransdell.vcf)</i></body></html>=

--=_related 005333BF85256EF6_=--
--=_mixed 005333BD85256EF6_=
Content-Type: application/octet-stream; name=ransdell.vcf
Content-Disposition: attachment; filename=ransdell.vcf
Content-ID: <1__=[email-masked]>
Content-Transfer-Encoding: base64

QkVHSU46VkNBUkQNClgtTE9UVVMtQ0hBUlNFVDpVVEYtOA0KVkVSU0lPTjozLjANClBST0RJRDot
Ly9Mb3R1cyBEZXZlbG9wbWVudCBDb3Jwb3JhdGlvbi8vTk9OU0dNTCBOb3RlcyA2LjAvL0VODQpG
TjpSb2JlcnQgVGhvbWFzIFJhbnNkZWxsDQpOOlJhbnNkZWxsO1JvYmVydDtUaG9tYXM7Ow0KRU1B
SUw6cm9iZXJ0X3JhbnNkZWxsQG5vdGVzZGV2LmlibS5jb20NCk9SRzpJQk0NClJFVjoyMDA0MDgy
MFQxNTA3MzhaDQpFTkQ6VkNBUkQNCg==

--=_mixed 005333BD85256EF6_=--

"Cameron Stillion" <[email-masked]> 
Sent by: [email-masked]
08/19/2004 06:41 PM

To
<[email-masked]>, <[email-masked]>
cc

Subject
RE: [Ietf-calsify] ALTREP and ATTACH

multipart/related
 |
 \_text/ical
 |
 \_text/html
 |
 \_multipart/mixed
    |
    \_ image/gif
    |
    etc...

Cameron

-----Original Message-----

To

Subject

Example:

     Content-Type:text/html

     <html><body>

 
 
cameron